/*
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this code; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.  */

/* Copyright (C) 2002 Ian Zimmerman <itz@speakeasy.org> */

#ifndef INCLUDE_BITSETS_H
#define INCLUDE_BITSETS_H

#include <limits.h>

/* $Id: bitsets.h,v 1.2 2002/06/17 07:47:49 itz Exp $ */

#define declare_bits(name, size) unsigned long name[(size)/(sizeof(unsigned long)*CHAR_BIT) + 1]
#define set_bit(name, index) (name[(index)/(sizeof(unsigned long)*CHAR_BIT)] |= (1 << ((index) % (sizeof(unsigned long)*CHAR_BIT))))
#define clear_bit(name, index) (name[(index)/(sizeof(unsigned long)*CHAR_BIT)] &= ~(1 << ((index) % (sizeof(unsigned long)*CHAR_BIT))))
#define test_bit(name, index) (0 != (name[(index)/(sizeof(unsigned long)*CHAR_BIT)] & (1 << ((index) % (sizeof(unsigned long)*CHAR_BIT)))))

#endif /* INCLUDE_BITSETS_H */
